<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_practice_insurance".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderPracticeInsurance".
 *
 * Columns in table "provider_practice_insurance" available as properties of the model,
 * followed by relations of table "provider_practice_insurance" available as properties of the model.
 *
 * @property integer $id
 * @property integer $provider_id
 * @property integer $company_id
 * @property integer $practice_id
 * @property integer $insurance_id
 * @property integer $network_status
 * @property string $details
 * @property string $date_added
 *
 * @property Provider $provider
 * @property Practice $practice
 * @property Insurance $insurance
 */
abstract class BaseProviderPracticeInsurance extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_practice_insurance';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderPracticeInsurance|ProviderPracticeInsurances', $n);
    }

    public static function representingColumn()
    {
        return 'details';
    }

    public function rules()
    {
        return array(
            array('provider_id, company_id, practice_id, insurance_id', 'required'),
            array('provider_id, company_id, practice_id, insurance_id, network_status', 'numerical', 'integerOnly' => true),
            array('details', 'length', 'max' => 255),
            array('date_added', 'safe'),
            array('network_status, details, date_added', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, provider_id, company_id, practice_id, insurance_id, network_status, details, date_added', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
            'practice' => array(self::BELONGS_TO, 'Practice', 'practice_id'),
            'insurance' => array(self::BELONGS_TO, 'Insurance', 'insurance_id'),
            'insuranceCompany' => array(self::BELONGS_TO, 'InsuranceCompany', 'company_id')
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'provider_id' => 'Provider',
            'company_id' => Yii::t('app', 'Insurance Company'),
            'practice_id' => 'Practice',
            'insurance_id' => Yii::t('app', 'Insurance'),
            'network_status' => Yii::t('app', 'Network Status'),
            'details' => Yii::t('app', 'Details'),
            'date_added' => Yii::t('app', 'Date Added'),
            'provider' => null,
            'practice' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('company_id', $this->company_id);
        $criteria->compare('practice_id', $this->practice_id);
        $criteria->compare('insurance_id', $this->insurance_id);
        $criteria->compare('network_status', $this->network_status);
        $criteria->compare('details', $this->details, true);
        $criteria->compare('date_added', $this->date_added, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
